// Request data transfer (and optionally wait till completed).

#include "std.h"

int main(int argc, char* argv[]) {
  LogTime::active=false;
  bool verbose = false;
  list<string> sources;
  for(;;) {
    opterr=0;
    int optc=getopt(argc,argv,"+hvd:lL");
    if(optc == -1) break;
    switch(optc) {
      case 'h': {
        olog<<"ngrequest [-h] [-v] [-d level] [-s source] destination"<<endl;
        olog<<" -h - print help"<<endl;
        olog<<" -v - print version"<<endl;
        olog<<" -d - set debug level"<<endl;
        olog<<" -s - source of data (can be multiple)"<<endl;
        return 1;
      }; break;
      case 'v': {
        olog<<"ngls: version "<<VERSION<<endl;
        return 0;
      };
      case 's': {
        sources.push_back(string(optarg));
      }; break;
      case 'd': {
        char* p;
        int i = strtol(optarg,&p,10);
        if(((*p) != 0) || (i<0)) {
          olog<<"Improper debug level '"<<optarg<<"'"<<endl;
          return 1;
        };
        verbose=true;
        LogTime::level=i;
      }; break;
      case '?': {
        olog<<"Unsupported option '"<<(char)optopt<<"'"<<endl;
        return 1;
      }; break;
      case ':': {
        olog<<"Missing parameter for option '"<<(char)optopt<<"'"<<endl;
        return 1;
      }; break;
      default: {
        olog<<"Undefined processing error"<<endl;
        return 1;
      };
    };
  };
  char* service_url = argv[optind+0];
  if(service_url == NULL) {
    olog<<"Missing service url" << endl; return 1;
  };
  if(argv[optind+1] != NULL) {
    olog<<"Unrecognized option: "<<argv[optind+1]<<endl; return 1;
  };
  DataPoint url(service_url);
  if(!url) {
    olog<<"Unsupported service url given"<<endl; return 1;
  };
  if(url.meta()) {
    olog<<"Meta-url for service is not supported yet"<<endl; return 1;
  };
  if(strncasecmp(service_url,"se://",5) == 0) {
    // send request to SSE 



  } else if(strncasecmp(service_url,"gsiftp://",9) {
    olog<<"GridFTP is not supported yet"<<endl; return 1;
  } else {
    olog<<"URL "<<service_url<<" is not supported"<<endl; return 1;
  };
  return 0;
}
